// GoalieStrategie.java stand: 20020707
/**
 * Goalie Strategie: die "Intelligenz" des Torhueters, waehlt anhand der
 *                   gegebenen absoluten Daten die passenden Aktionen
 *                   und fuehrt diese aus.
 *
 * @author <a href="mailto:trcsystems@gmx.de">Christian Roth</a>
 * @author <a href="mailto:bjoernschieber@web.de">Bjrn Schieber</a>
 * @author <a href="mailto:rmathes@uni-mannheim.de">Rene M</a>
 * @author <a href="mailto:dabrecht@uni-mannheim.de">David Brechtel</a>
 * @version 0.0.1
 * @see <code>Weltbild</code>
 * @see <code>kommunikation</code>
 * @see <code>Loki</code>
 * @see <code>Strategie</code>
 * @see <code>SpielerStrategie</code>
 */
public class GoalieStrategie extends Strategie {

  private WbObjekt[] WbObjekte;
  private WbObjekt ball, spieler, spiel;
  private kommunikation kom;
  private int aufgestellt = 0;
  private boolean gedreht = false;

  public GoalieStrategie() {
    System.out.println( "GoalieStrategie: wird geladen..." );
    WbObjekte = new WbObjekt[24];
    spieler = WbObjekte[0];
    ball = WbObjekte[1];
    spiel = WbObjekte[2];
  }

  public boolean handle( kommunikation kom, WbObjekt[] WbObjekte )
  {
    boolean stillRunning = true;
    spieler = WbObjekte[0];
    ball = WbObjekte[1];
    spiel = WbObjekte[2];

    this.WbObjekte = WbObjekte;
    this.kom = kom;
    try
    {
      String status = spiel.status();
//      System.out.println( "GoalieStrategie: Schiedsrichternachricht = " +status );

/**
 * alle moeglichen Nachrichten des Schiedsrichters
 * alle moeglichen Spieltati abarbeiten.
 */
      if( ( status.equals("before_kick_off") ) || ( status.startsWith( "goal_" ) ) )
      {
        if( status.startsWith( "goal_kick_" ) ) {
          if( status.indexOf( "_"+( spiel.seite() == 1 ? "l" : "r " ) ) > -1 ) {
            eigener_goal_kick();
          } else {
            gegner_goal_kick();
          }
        } else if( aufgestellt == 0 ) {
          aufstellen();
          aufgestellt = 1;
        } else if( !gedreht ){
          if( spiel.seite() == -1 ){ kom.turn( 180 ); }
          gedreht = true;
        }
      }
      else if( ( status.equals( "play_on" ) ) || ( status.equals( "drop_ball" ) ) )
      {
        play_on();
      }
      else if( ( status.equals( "time_over" ) ) || ( status.startsWith( "time_up" ) ) ) {
        /** das spiel ist zuende, vom server abmelden... */
        kom.bye();
        /** flag zum beenden des spiels setzen... */
        stillRunning = false;
      }
      else if( status.startsWith( "kick_off" ) )
      {
        if( status.indexOf( "_"+( spiel.seite() == 1 ? "l" : "r " ) ) > -1 ) {
          eigener_kick_off();
        } else {
          gegner_kick_off();
        }
      }
      else if( status.startsWith( "kick_in" ) )
      {
        if( status.indexOf( "_"+( spiel.seite() == 1 ? "l" : "r " ) ) > -1 ) {
          eigener_kick_in();
        } else {
          gegner_kick_in();
        }
      }
      else if( status.startsWith( "free_kick" ) )
      {
        if( status.indexOf( "_"+( spiel.seite() == 1 ? "l" : "r " ) ) > -1 ) {
          eigener_free_kick();
        } else {
          gegner_free_kick();
        }
      }
      else if( status.startsWith( "corner_kick" ) )
      {
        if( status.indexOf( "_"+( spiel.seite() == 1 ? "l" : "r " ) ) > -1 ) {
          eigener_corner_kick();
        } else {
          gegner_corner_kick();
        }
      }
      else if( status.startsWith( "offside" ) )
      {
        if( status.indexOf( "_"+( spiel.seite() == 1 ? "l" : "r " ) ) > -1 ) {
          eigener_offside();
        } else {
          gegner_offside();
        }
      }
      else if( status.startsWith( "foul" ) )
      {
        if( status.indexOf( "_"+( spiel.seite() == 1 ? "l" : "r " ) ) > -1 ) {
          eigener_foul();
        } else {
          gegner_foul();
        }
      }
      else if( status.startsWith( "goalie_catch_ball" ) )
      {
        if( status.indexOf( "_"+( spiel.seite() == 1 ? "l" : "r" ) ) > -1 ) {
          eigener_goalie_catch_ball();
        } else {
          gegner_goalie_catch_ball();
        }
      }
      else if( status.equals( "half_time" ) )
      {
        half_time();
      }
      else if( status.equals( "time_extended" ) )
      {
        time_extended();
      }
      else
      {
//        System.out.println( "GoalieStrategie: Status nicht erkannt, gehe auf play_on" );
        play_on();
      }
    }
    catch(NullPointerException npe)
    {
//      System.out.println("GoalieStrategie: " + npe);
    }
    return stillRunning;
  }

/**
 * unterfunktionen
 */

/**
 * offensiv() - wir spielen offensiv
 */
  private void offensiv() {
    play_on();
  }

/**
 * defensiv() - wir spielen defensiv
 */
  private void defensiv() {
    play_on();
  }

 /**
 * play_on() - was ist zu tun, wenn wir im spiel sind?
 */
  private void play_on()
  {
    aufgestellt = 0;
    gedreht = false;
    double deltaX = ( 57.5 - spiel.seite()*52.5 ) - spieler.positionX();
    double deltaY = ( 39 ) - spieler.positionY();
    double entfernungZumTor = Math.sqrt( deltaX*deltaX + deltaY*deltaY );
    /*
    System.out.println( "GoalieStrategie: spieler.positionX = " +spieler.positionX() );
    System.out.println( "GoalieStrategie: deltaX = " +deltaX );
    System.out.println( "GoalieStrategie: deltaY = " +deltaY );
    System.out.println( "GoalieStrategie: entfernungZumTor = " +entfernungZumTor );
    */
    // sicherheitshalber
    if( spieler.richtung() != -1000 )
    {
      // koennen wir den ball fangen?
      if( entfernungZumTor <= 16 )
      {
        if( ball.positionX() >= 0 )
        {
          if( ball.entfernung() < 2 ) { kom.fange( ball.relativer_winkel() ); }
          else if( ball.entfernung() < 12 )
          {
            if( Math.abs( ball.relativer_winkel() ) < 30 ) { kom.dash( 100 ); }
            else { renneZumTor( deltaX, deltaY, entfernungZumTor ); }
          }
          else if( ball.entfernung() > 20 )
          {
            renneZumTor( deltaX, deltaY, entfernungZumTor );
          }
        }
        else
        {
          if( entfernungZumTor > 8 )
          {
            renneZumTor( deltaX, deltaY, entfernungZumTor );
          }
          else
          {
            kom.turn( 60 );
          }
        }
      }
      else
      {
        if( ball.positionX() >= 0 )
        {
          if( ball.entfernung() <= 0.7 ) { schiesse(); }
        }
        else { renneZumTor( deltaX, deltaY, entfernungZumTor ); }
      }
    }
    else { kom.turn( 40 ); }
  }


/**
  * renneZumTor() - laesst den Torhueter zum Tor zurueckkehren
  *
  * @param <code>double</code> deltaX : X entfernung
  * @param <code>double</code> deltaY : Y entfernung
  * @param <code>double</code> entfernungZumTor: errechnete entferung
  */
  private void renneZumTor( double deltaX, double deltaY, double entfernungZumTor )
  {
    if( spieler.richtung() == -1000 ) { kom.turn( 40 ); }
    else
    {
      if( Math.abs( spieler.richtung() ) > 165 )
      {
        if( entfernungZumTor > 12 )
        {
          kom.dash( 100 );
        }
        else
        {
          kom.dash( 50 );
        }
      }
      else { kom.turn( bereinigt( 180 - spieler.richtung() ) ); }
    }
  }

/**
 * schiesse() - schiesst den ball.
 */
  private void schiesse()
  {
    if( spieler.richtung() != -1000 )
    {
      int leererSektor = 0;
      int minGegner = 1000;
      int i = 0;
      int j = 0;
      for( i=-3;i<4;i++ ) {
        int gegner = 0;
        for( j=3;j<24;j++ ) {
          if( ( WbObjekte[ j ] != null ) && ( WbObjekte[ j ].mannschaft() != 1 ) && ( Math.abs( WbObjekte[ j ].winkel() - i*10 ) <= 5 ) )
          {
            gegner++;
//            System.out.println( "GoalieStrategie: Gegner Nr. " +gegner +" gefunden." );
          }
        }
        if( gegner < minGegner )
        {
          minGegner = gegner;
          leererSektor = i;
        }
      }
//      System.out.println( "GoalieStrategie: leererSektor = " +leererSektor + " ; blickrichtung = " +spieler.blickrichtung() );
      kom.kick( 100, ( leererSektor*10 ) -spieler.blickrichtung() );
    }
    else
    {
      kom.turn( 40 );
    }
  }

// war mal in play_on();
  /*
    // erstmal ball suchen...
    if( ball.positionX() >= 0 ) {
    // ball gefunden
      if( ball.entfernung() < 2 ) {
        kom.fange( -ball.relativer_winkel() );
      }
      else if( ball.entfernung() < 5 ) {
// entfernung zu unserem tor ueberpruefen
// wenn zu gross, erstmal zurueck zum tor
// wenn nicht, dann hin zum ball...
        if( entfernungOk() ) {
          if( ball.relativer_winkel() < 5 ) {
            kom.dash( 30 );
          } else {
            kom.turn( ball.relativer_winkel() );
          }
        }
      } else {
      // ball ist zu weit weg... wie stehen wir?
        if( entfernungOk() ) {
          // hier koennte man nochwas machen...
        }
      }
    } else {
    // ball nich gefunden, wenn wir nah genug beim tor stehen dann drehen...
      if( entfernungOk() ) { kom.turn( 60 ); }
    }
*/

  /**
   * boolean entfernungOk() - ueberprueft die entfernung des Torhueters von
   *                          seinem tor, und rennt ggf zum tor zurueck.
   * @return <code>boolean</code> istOk : (distance<8?true:false)
   */
/*
  private boolean entfernungOk() {
    boolean istOk = false;
    double deltaX = ( 57.5 - spiel.seite()*52.5 ) - spieler.positionX();
    double deltaY = ( 39 ) - spieler.positionY();
    double distance = Math.sqrt( deltaX*deltaX + deltaY*deltaY );
    if( distance > 8 ) {
      // zu weit vom tor weg, erstmal wieder zurueck
      double eigentliche_richtung = eigentliche_richtung(deltaX, deltaY);
      double eigene_richtung = spieler.richtung();
      double richtung = bereinigt( eigentliche_richtung - eigene_richtung );
      if( Math.abs( richtung ) < 5 ) {
        kom.dash( 80 );
      } else {
        kom.turn( richtung );
      }
    } else {
      istOk = true;
    }
    return istOk;
  }
*/


/**
 * aufstellen() - entscheidet, wie unsere spieler sich aufstellen...
 */
  public void aufstellen()
  {
    // nur vorlaeufig, wird vielleicht noch erweitert...
    int spielmodus = OFFENSIV;
    int nummer = spieler.nummer() -1;
//    System.out.println( "Strategie: bringe Spieler "+nummer+" an seine Position..." );
    kom.move( xPosition[ spielmodus ][ spieler.nummer()-1 ], yPosition[ spielmodus ][ spieler.nummer()-1 ] );
  }

 /**
  * eigener_kick_off() - was passiert wenn wir anstoss haben?
  */
  private void eigener_kick_off()
  {
    offensiv();
  }

/**
 * gegner_kick_off() - was passiert wenn der gegner anstoss hat?
 */
  private void gegner_kick_off()
  {
    defensiv();
  }

 /**
  * eigener_goal_kick() - was passiert wenn wir abstoss haben?
  */
  private void eigener_goal_kick()
  {
//    System.out.println( "GoalieStrategie: in eigener_goal_kick" );
    if( ball.entfernung() <= 0.7 ) {

      // Abfrage, ob Gegenspieler in der Nhe stehen...

      if( spieler.richtung() != -1000 ) { kom.kick( 100, -spieler.richtung() ); }
    } else if( Math.abs( ball.relativer_winkel() ) < 3 ) {
      kom.dash( 70 );
    } else {
      kom.turn( ball.relativer_winkel() );
    }
  }

/**
 * gegner_goal_kick() - was passiert wenn der gegner abstoss hat?
 */
  private void gegner_goal_kick()
  {
    defensiv();
  }

  private void eigener_free_kick()
  {
//    offensiv();
    schiesse();
  }

  private void gegner_free_kick()
  {
    defensiv();
  }

  private void eigener_kick_in()
  {
    offensiv();
  }

  private void gegner_kick_in()
  {
    defensiv();
  }

  private void eigener_corner_kick()
  {
    offensiv();
  }

  private void gegner_corner_kick()
  {
    defensiv();
  }

  private void eigener_offside()
  {
    defensiv();
  }

  private void gegner_offside()
  {
    offensiv();
  }

  private void eigener_foul()
  {
    defensiv();
  }

  private void gegner_foul()
  {
    offensiv();
  }

  private void eigener_goalie_catch_ball()
  {
    // nur vorlaeufig...
    int spielmodus = OFFENSIV;
    kom.move( xPosition[ spielmodus ][ spieler.nummer()-1 ], yPosition[ spielmodus ][ spieler.nummer() -1 ] );
    kom.kick( 100, -spieler.richtung() );
  }

  private void gegner_goalie_catch_ball()
  {
    defensiv();
  }

  private void half_time()
  {
    aufstellen();
  }

  private void time_extended()
  {
    aufstellen();
  }
/**
 * <code>double</code> eigentliche_richtung - genau das selbe wie in der
 * <code>SpielerStrategie</code> auch
 */
  private double eigentliche_richtung(double x, double y)
  {
    double eigentliche_richtung = -1000;
    double beta = Math.toDegrees( Math.atan(Math.abs( y/x ) ) );
    //System.out.println(" beta: " + beta);

    if((x >= 0) && (y >= 0))
    {
      //System.out.println("x >= 0, y >= 0");
      if(spiel.seite() == 1)
      {
        eigentliche_richtung = beta;
      }
      else if(spiel.seite() == -1)
      {
        eigentliche_richtung = -180 + beta;
      }
    }
    else if((x >= 0) && (y < 0))
    {
      //System.out.println("x >= 0, y < 0");
      if(spiel.seite() == 1)
      {
        eigentliche_richtung = -beta;
      }
      else if(spiel.seite() == -1)
      {
        eigentliche_richtung = 180 - beta;
      }
    }
    else if((x < 0) && (y >= 0))
    {
      //System.out.println("x < 0, y >= 0");
      if(spiel.seite() == 1)
      {
        eigentliche_richtung = 180 - beta;
      }
      else if(spiel.seite() == -1)
      {
        eigentliche_richtung = -beta;
      }
    }
    else if((x<0) && (y<0))
    {
      //System.out.println("x < 0, y < 0");
      if(spiel.seite() == 1)
      {
        eigentliche_richtung = -180 + beta;
      }
      else if(spiel.seite() == -1)
      {
        eigentliche_richtung = beta;
      }
    }

    //System.out.println("eigentliche Richtung: " + eigentliche_richtung);
    return eigentliche_richtung;
  }

  private double bereinigt(double wert)
  {
    if(wert > 180)
    {
      wert = wert - 360;
    }
    else if(wert < -180)
    {
      wert = wert + 360;
    }
    return wert;
  }

}
// ende der Klasse GoalieStrategie