// MeinPanel.java

/** 
* Die Klasse MeinPanel erstellt ein Zeichenbrett auf welchem das Spielfeld
* gezeichnet wird und stellt die Methode zur Verfgung mit welcher das 
* Weltbild immer wieder neu gezeichnet wird. 

 * @author <a href="mailto:StephanOswald@web.de">Stephan Oswald</a>
 * @author <a href="mailto:ismet@erdem.org">Ismet Erdem</a>
 * @version 1.0
 * @see <code>Visualisierung</code>
 */
/** Importieren der Graphik Klassen. AWT zum zeichnen der Kreise, Swing

* fr das Panel

*/

import java.awt.event.*;

import java.awt.*;

import javax.swing.*;





public class MeinPanel extends JPanel

{



    private WbObjekt[] objekte;

    public MeinPanel meinpanel;

    /** Konstruktor der das Spielfeld und die Spieler zeichnet

    */

    public MeinPanel()

    {

	this.setBackground(new Color(47, 152, 35));

	this.setPreferredSize(new Dimension(1024,740));



    }


    /** Mehthode paintComponent zeichnet das Spielfeld, die Spieler und den Ball
     */
	public void paintComponent(Graphics g)

	{

	   super.paintComponent(g);

	   g.setColor(SystemColor.white);



	   /** Spielfeld zeichnen

	   * Auslinien zeichnen

           */

	   g.drawLine(45,70,45,682);

	   g.drawLine(45,70,990,70);

	   g.drawLine(990,70,990,682);

	   g.drawLine(45,682,990,682);



	   /** Mittellinie
 zeichnen

           */

	   g.drawLine(517,70,517,682);



	   /** Strafraeume
 zeichnen


           */

	   g.drawRect(45,295,60,162);

	   g.drawRect(45,196,150,360);

	   g.drawRect(930,295,60,162);

	   g.drawRect(840,196,150,360);



 	   /** Mittelkreis
 zeichnen


           */

	   g.drawOval(437,296,165,160);



	   g.setColor(SystemColor.black);



	   /** Tor
 zeichnen


           */

	   g.drawLine(45,313,45,439);

	   g.drawLine(990,313,990,439);







	   /** Array zum Speichern der von der Visualisierung angepassten

            *  Postionsdaten aus dem Weltbild

           */

	   int[] x = new int[ 24 ];

	   int[] y = new int[ 24 ];

	   int i = 0;



	   /** Berechnung der Koordinaten fr unseren Spieler

            *  (i=0) und den Ball (i=1)

           */

	   for( i=0;i<2;i++)

	   {

		try

		{

		   if(objekte[i]!=null)

		   {

	     	   	x[ i ] = (int)( Math.round( objekte[ i ].positionX() *9 ) );

	     	    	y[ i ] = (int)( Math.round( objekte[ i ].positionY() *9+25 ) );

	   	   }

		}

	   	catch (NullPointerException e) {};

	   }



    	   /** Berechnung der Koordinaten fr die anderen Spieler

           */

    	   for( i=3;i<24;i++)

	   {

	      try

	      {

	     	if(objekte[i]!=null)

	     	{

	     	   x[ i ] = (int)( Math.round( objekte[ i ].positionX() *9 ) );

	     	   y[ i ] = (int)( Math.round( objekte[ i ].positionY() *9+25 ) );

             	   //System.out.println( "Visualisierung ab i=3: xpos : ypos: "+x[ i ]+ " : "+y[ i ] );

	      	}

	      }

	      catch (NullPointerException e) {};



	   }

	   /** Spieler wird gezeichnet

           */

	   g.setColor(SystemColor.black);

	   g.fillOval(x[ 0 ], y[ 0 ],10,10);

	   /** Ausrichtung des Spielers wird anhand der Richtungsangabe aus dem

          * Weltbild berechnet und dann als Linie in die Entsprechende Richtung
	    * gezeichnet.
          */

	   try

	   {

	   int richtung = (int)( Math.round( objekte[ 0 ].richtung()+180 ) );

	   if (objekte[ 2 ].seite() == 1)

	   {



		if((0 < richtung) && (richtung < 22) || ( 338 < richtung) && (richtung < 360))

	   	{



		   g.drawLine(x[ 0 ]+5, y[ 0 ]+5,x[ 0 ]-5, y[ 0 ]+5);



	   	}

	   	if((22 < richtung) && (richtung < 67))

	   	{



		   g.drawLine(x[ 0 ]+5, y[ 0 ]+5,x[ 0 ]-5, y[ 0 ]-5);



	   	}

	   	if((68 < richtung) && (richtung < 113))

	   	{



		   g.drawLine(x[ 0 ]+5, y[ 0 ]+5,x[ 0 ]+5, y[ 0 ]-5);



	   	}

	   	if((113 < richtung) && (richtung < 158))

	   	{



		   g.drawLine(x[ 0 ]+5, y[ 0 ]+5,x[ 0 ]+15, y[ 0 ]-5);



	   	}

	   	if((158 < richtung) && (richtung < 203))

	   	{



		   g.drawLine(x[ 0 ]+5, y[ 0 ]+5,x[ 0 ]+15, y[ 0 ]+5);



	   	}

	   	if((203 < richtung) && (richtung < 248))

	   	{



		   g.drawLine(x[ 0 ]+5, y[ 0 ]+5,x[ 0 ]+15, y[ 0 ]+15);



	   	}

	   	if((248 < richtung) && (richtung < 293))

	   	{



		   g.drawLine(x[ 0 ]+5, y[ 0 ]+5,x[ 0 ]+5, y[ 0 ]+15);



	   	}

	   	if((293 < richtung) && (richtung < 338))

	    	{



		   g.drawLine(x[ 0 ]+5, y[ 0 ]+5,x[ 0 ]-5, y[ 0 ]+15);



	   	}

	   }

	   if (objekte[ 2 ].seite() == -1)

	   {



		if((0 < richtung) && (richtung < 22) || ( 338 < richtung) && (richtung < 360))

	   	{



		   g.drawLine(x[ 0 ]+5, y[ 0 ]+5,x[ 0 ]+15, y[ 0 ]+5);



	   	}

	   	if((22 < richtung) && (richtung < 67))

	   	{



		   g.drawLine(x[ 0 ]+5, y[ 0 ]+5,x[ 0 ]+15, y[ 0 ]+15);



	   	}

	   	if((68 < richtung) && (richtung < 113))

	   	{



		   g.drawLine(x[ 0 ]+5, y[ 0 ]+5,x[ 0 ]+5, y[ 0 ]+15);



	   	}

	   	if((113 < richtung) && (richtung < 158))

	   	{



		   g.drawLine(x[ 0 ]+5, y[ 0 ]+5,x[ 0 ]-5, y[ 0 ]+15);



	   	}

	   	if((158 < richtung) && (richtung < 203))

	   	{



		   g.drawLine(x[ 0 ]+5, y[ 0 ]+5,x[ 0 ]-5, y[ 0 ]+5);



	   	}

	   	if((203 < richtung) && (richtung < 248))

	   	{



		   g.drawLine(x[ 0 ]+5, y[ 0 ]+5,x[ 0 ]-5, y[ 0 ]-5);



	   	}

	   	if((248 < richtung) && (richtung < 293))

	   	{



		   g.drawLine(x[ 0 ]+5, y[ 0 ]+5,x[ 0 ]+5, y[ 0 ]-5);



	   	}

	   	if((293 < richtung) && (richtung < 338))

	    	{



		   g.drawLine(x[ 0 ]+5, y[ 0 ]+5,x[ 0 ]+15, y[ 0 ]-5);



	   	}

	   }

	   }

	   catch (NullPointerException e) {};



	   /** Ball wird gezeichnet

           */

	   g.setColor(SystemColor.white);

	   g.fillOval(x[ 1 ], y[ 1 ],10,10);



	   /** Andere Spieler werden gezeichnet

           */

    	   for ( i=3;i<24;i++ )

    	   {

	      try

	      {

         	/** berprfung ob Spieler sichtbar

                */

		if(objekte[i]!=null)

		{

	 	   /** Rckennummer des Spielers wird festgestellt

                   */

		   int nummer = objekte[ i ].nummer();

		   String str = ""+ nummer;

		   if (nummer == -1)

		   {  str = "?";

		   }



		   switch ( objekte[ i ].mannschaft())

		   {

			/** Spieler ist ein Mitspieler

                        */

		    	case 1:

			{

			   g.setColor(SystemColor.blue);

			   g.fillOval(x[ i ],y[ i ],10,10);

			   g.drawString(str,x[ i ],y[ i ]);

	                   break;

	    		}

			/** Spieler ist ein Gegenspieler

                        */

			case -1:

			{

			   g.setColor(SystemColor.red);

			   g.fillOval(x[ i ],y[ i ],10,10);

    			   g.drawString(str,x[ i ],y[ i ]);



                	   break;

	    		}

			/** Leider ist unser Spieler kurzsichtig und kann nicht

                         *  erkennen ob es sich um einen

			 * Gegenspieler oder Mitspieler handelt

                        */

	    		case 0:

			{

			   g.setColor(SystemColor.yellow);

			   g.fillOval(x[ i ],y[ i ],10,10);

                	   break;

	    		}



		   }

		}

	     }

	     catch (NullPointerException e) {};

	   }



	}

    public void drawString(String str, int x, int y){};



    /** Funktion welche von der Visualisierung aufgrufen wird um das Spielfeld

     *  neu zu zeichnen

    */

    public void zeichne( WbObjekt[] objekte )

    {

    this.objekte = objekte;

    repaint();

    }





}

