// RoboClient stand: 20020707
/**
 * RoboClient: unsere Huellenklasse, kann vom prompt gestartet werden.
 *
 *  uebernimmt:
 *  <ul><li>Anmeldung einer kompletten Mannschaft am Server</ul>
 *
 * @author <a href="mailto:dabrecht@uni-mannheim.de">David Brechtel</a>
 * @author <a href="mailto:rmathes@uni-mannheim.de">Rene M</a>
 * @version 0.0.1
 * @see <code>Loki</code>
 */
public class RoboClient
{

  private static final String VERSION = "0.0.1";
  private static final int NUM_PLAYERS = 11;

  /**
   * in diesem array wird unsere mannschaft instanziert.
   */
  private static Loki[] loki = new Loki[ NUM_PLAYERS ];

  /**
   * displaySyntax() - wird bei angabe von falschen parametern aufgerufen
   */
  private static void displaySyntax() {
    System.out.println( "Syntax:\nRoboClient <teamName> [serverName|serverIp] [serverPort] [-visual[N]]\n" );
    System.out.println( "der Name des Teams muss angegeben werden, alle anderen Parameter sind optional." );
    System.out.println( "um die Visualisierung fuer einen bestimmten spieler zu starten bitte -visualN benutzen,");
    System.out.println( "wobei N im Bereich von 1 bis 11 liegen sollte. Wird N nicht angegben, wird ein Spieler zufaellig ausgewaehlt.\n\n" );
  }

  /**
   * void main( String[] args ) - die hauptklasse des RoboClient
   * wird verwendet um die parameter zu parsen und die mannschaft
   * zu instanzieren.
   */
  public static void main( String[] args ) {
    String serverName = "localhost";
    int serverPort = 6000;
    String teamName = "";
    /** fuer die visualisierung */
    boolean visible = false;
    int randomVisible = (int)Math.floor( NUM_PLAYERS * Math.random() +0.5 );
    System.out.println( "\n\nRoboClient - RoboCup Soccer Mannschaft version " + VERSION + " ; Gruppe 15\n\n" );
    /** parsing der kommandozeilen parameter */
    if( args.length == 0) {
      displaySyntax();
      System.exit( 1 );
    } else {
      teamName = args[ 0 ];
      if( args.length >1 ) {
        if( args[ 1 ].startsWith( "-visual" ) ) {
       	  visible = true;
          try {
            randomVisible = ( Integer.parseInt( args[ 1 ].substring( 7 ).trim() ) ) % NUM_PLAYERS;
            System.out.println( "Visualisierung wird fuer Spieler "+randomVisible+" aktiviert." );
          } catch( NumberFormatException NFE ) {
            randomVisible = (int)Math.floor( NUM_PLAYERS * Math.random() +0.5 );
            System.out.println( "Parameter 2 nicht erkannt, sollte -visualN sein, ist: "+args[ 1 ]+"\nDie Visualisierung wurde zufaellig fuer Spieler Nummer "+(randomVisible +1)+" gewaehlt.\n" );
          }
       	} else {
       	  serverName = args[ 1 ];
       	}
      }
      if( args.length >2 ) {
        serverName = args[ 1 ];
       	if( args[ 2 ].startsWith( "-visual" ) ) {
       	  visible = true;
          try {
            randomVisible = ( Integer.parseInt( args[ 2 ].substring( 7 ).trim() ) ) % NUM_PLAYERS;
              System.out.println( "Visualisierung wird fuer Spieler "+randomVisible+" aktiviert." );
          } catch( NumberFormatException NFE ) {
              randomVisible = (int)Math.floor( NUM_PLAYERS * Math.random() +0.5 );
              System.out.println( "Parameter 3 nicht erkannt, sollte -visualN sein, ist: "+args[ 2 ]+"\nDie Visualisierung wurde zufaellig fuer Spieler Nummer "+(randomVisible +1)+" gewaehlt.\n" );
          }
       	} else {
          try {
            serverPort = Integer.parseInt( args[ 2 ] );
          } catch( NumberFormatException NFE ) {
            System.out.println( "Parameter 3 nicht erkannt, sollte serverPort sein, ist: "+args[ 2 ]+"\n\n" );
            displaySyntax();
            System.exit( 1 );
          }
       	}
      }
      if( args.length >3 ) {
        try {
          serverPort = Integer.parseInt( args[ 2 ] );
        } catch( NumberFormatException NFE ) {
          System.out.println( "Parameter 3 nicht erkannt, sollte serverPort sein, ist: "+args[ 2 ]+"\n\n" );
          displaySyntax();
          System.exit( 1 );
        }
        if( args[ 3 ].startsWith( "-visual" ) ) {
       	  visible = true;
          try {
            randomVisible = ( Integer.parseInt( args[ 3 ].substring( 7 ).trim() ) ) % NUM_PLAYERS;
            System.out.println( "Visualisierung wird fuer Spieler "+randomVisible+" aktiviert." );
          } catch( NumberFormatException NFE ) {
            randomVisible = (int)Math.floor( NUM_PLAYERS * Math.random() +0.5 );
            System.out.println( "Parameter 4 nicht erkannt, sollte -visualN sein, ist: "+args[ 3 ]+"\nDie Visualisierung wurde zufaellig fuer Spieler Nummer "+(randomVisible +1)+" gewaehlt.\n" );
          }
       	}
      }
    }
    /** ende des parsing */
    /** und Loki instanzieren...*/
    // einen Loki als goalie instanzieren...
    loki[ 0 ] = new Loki( serverName, serverPort, teamName, true, ( randomVisible == 0 ) && ( visible ) );
    // den rest als normale spieler
    int i = 0;
    for( i=1;i<NUM_PLAYERS;i++ ) {
      loki[ i ] = new Loki( serverName, serverPort, teamName, false, ( randomVisible == i ) && ( visible ) );
    }
    // und alle Lokis starten.
    for( i=0;i<NUM_PLAYERS;i++ ) {
      System.out.println( "RoboClient: Starte Loki Nummer: "+( i+1 ) );
      loki[ i ].start();
    }

    /**
     * die Lokis laufen als threads und beenden sich bei spielende selbst.
     */
    while( loki[ NUM_PLAYERS -1 ].isAlive() ) {
    // wir warten dass die Lokis sich beenden...
    }
    System.out.println( "RoboClient beendet..." );
  }
  // ende von main();
}
// ende der klasse RoboClient.
