// SpielerStrategie.java stand: 20020707
/**
 * SpielerStrategie: die "Intelligenz" des Spielers, waehlt anhand der
 *                   gegebenen absoluten Daten die passenden Aktionen
 *                   und fuehrt diese aus.
 *
 * @author <a href="mailto:trcsystems@gmx.de">Christian Roth</a>
 * @author <a href="mailto:bjoernschieber@web.de">Bjrn Schieber</a>
 * @author <a href="mailto:dabrecht@uni-mannheim.de">David Brechtel</a>
 * @author <a href="mailto:rmathes@uni-mannheim.de">Rene M</a>
 * @version 0.0.1
 * @see <code>Weltbild</code>
 * @see <code>kommunikation</code>
 * @see <code>Loki</code>
 * @see <code>Strategie</code>
 * @see <code>GoalieStrategie</code>
 */
public class SpielerStrategie extends Strategie {

/**
 * einige variablen die zum arbeiten gebraucht werden...
 */
  private WbObjekt[] WbObjekte;
  private WbObjekt ball, spieler, spiel;
  private kommunikation kom;
  private int aufgestellt = 0;
  private boolean gedreht = false;
  private int ballNotSeenCount = 0;

/**
 * SpielerStrategie() - unser konstruktor, initialisiert die Strategie
 */
  public SpielerStrategie()
  {
    System.out.println( "SpielerStrategie: wird geladen..." );
    WbObjekte = new WbObjekt[24];
    spieler = WbObjekte[0];
    ball = WbObjekte[1];
    spiel = WbObjekte[2];
  }

/**
 * handle( kommunikation kom, WbObjekt[] WbObjekte )
 * verwaltet die strategie
 *
 * @param <code>kommunikation</code> kom : das kommunikationsmodul
 * @param <code>WbObjekt[]</code WbObjekte: die Objekte des Weltbilds
 * @return <code>boolean</code> ("time_up"?true:false)
 */
  public boolean handle( kommunikation kom, WbObjekt[] WbObjekte )
  {
    boolean stillRunning = true;
    spieler = WbObjekte[0];
    ball = WbObjekte[1];
    spiel = WbObjekte[2];

    this.WbObjekte = WbObjekte;
    this.kom = kom;
    try
    {
      String status = spiel.status();
      //System.out.println( "SpielerStrategie: Schiedrichternachricht = " +status );

/**
 * alle moeglichen Nachrichten des Schiedsrichters
 * alle moeglichen Spieltati abarbeiten.
 */
      if( ( status.equals("before_kick_off") ) || ( status.startsWith( "goal_" ) ) )
      {
        if( status.startsWith( "goal_kick_" ) ) {
          if( status.indexOf( "_"+( spiel.seite() == 1 ? "l" : "r " ) ) > -1 ) {
            eigener_goal_kick();
          } else {
            gegner_goal_kick();
          }
        } else if( aufgestellt == 0 ) {
          aufstellen();
          aufgestellt = 1;
        } else if( !gedreht ) {
          if( spiel.seite() == -1 ) { kom.turn( 180 ); }
          gedreht = true;
        }
      }
      else if( ( status.equals( "play_on" ) ) || ( status.equals( "drop_ball" ) ) )
      {
        play_on();
      }
      else if( ( status.equals( "time_over" ) ) || ( status.startsWith( "time_up" ) ) ) {
        /** das spiel ist zuende, vom server abmelden... */
        kom.bye();
        /** flag zum beenden des spiels setzen... */
        stillRunning = false;
      }
      else if( status.startsWith( "kick_off" ) )
      {
        if( status.indexOf( "_"+(spiel.seite() == 1 ? "l" : "r" ) ) > -1 ) {
          eigener_kick_off();
        } else {
          gegner_kick_off();
        }
      }
      else if( status.startsWith( "kick_in" ) )
      {
        if( status.indexOf( "_"+( spiel.seite() == 1 ? "l" : "r " ) ) > -1 ) {
          eigener_kick_in();
        } else {
          gegner_kick_in();
        }
      }
      else if( status.startsWith( "free_kick" ) )
      {
        if( status.indexOf( "_"+( spiel.seite() == 1 ? "l" : "r " ) ) > -1 ) {
          eigener_free_kick();
        } else {
          gegner_free_kick();
        }
      }
      else if( status.startsWith( "corner_kick" ) )
      {
        if( status.indexOf( "_"+( spiel.seite() == 1 ? "l" : "r " ) ) > -1 ) {
          eigener_corner_kick();
        } else {
          gegner_corner_kick();
        }
      }
      else if( status.startsWith( "offside" ) )
      {
        if( status.indexOf( "_"+( spiel.seite() == 1 ? "l" : "r " ) ) > -1 ) {
          eigener_offside();
        } else {
          gegner_offside();
        }
      }
      else if( status.startsWith( "foul" ) )
      {
        if( status.indexOf( "_"+( spiel.seite() == 1 ? "l" : "r " ) ) > -1 ) {
          eigener_foul();
        } else {
          gegner_foul();
        }
      }
      else if( status.startsWith( "goalie_catch_ball" ) )
      {
        if( status.indexOf( "_"+( spiel.seite() == 1 ? "l" : "r " ) ) > -1 ) {
          eigener_goalie_catch_ball();
        } else {
          gegner_goalie_catch_ball();
        }
      }
      else if( status.equals( "half_time" ) )
      {
        half_time();
      }
      else if( status.equals( "time_extended" ) )
      {
        time_extended();
      }
      else
      {
        //System.out.println( "SpielerStrategie: Status " + status + " nicht erkannt, gehe auf play_on" );
        play_on();
      }
    }
    catch(NullPointerException npe)
    {
//      System.out.println("SpielerStrategie: " + npe);
    }
    return stillRunning;
  }

/**
 * unterfunktionen
 */

 /**
 * play_on() - was ist zu tun, wenn wir im spiel sind?
 */
  private void play_on() {
    aufgestellt = 0;
    gedreht = false;
    boolean amNaechsten = false;
    double distance = FEHLT;
    /** sehen wir den ball? */
    if( ball.positionX() >= 0 ) {
      // wenn wir den ball sehen sind wir sicherheitshalber erstmal am naechsten
      amNaechsten = true;
      ballNotSeenCount = 0;
      distance = ball.entfernung();
      try {
        // sind wir wirklich am naechsten am ball?
        int i = 0;
        for( i=3;( amNaechsten ) && ( i<24 );i++ ) {
          if( ( WbObjekte[ i ] != null ) && ( WbObjekte[ i ].mannschaft() == 1 ) && ( WbObjekte[ i ].nummer() != 1 ) ) {
            if( Math.abs( WbObjekte[ i ].ballEntfernung() ) < distance ) {
              amNaechsten = false;
            }
          }
        }
      } catch( NullPointerException NPE ) {
//        System.out.println( "Strategie: 'normale' exception in play_on() NPE " +NPE );
      }
    } else {
      // wir sehen den ball nicht
      ballNotSeenCount++;
    }
    // wenn wir am naechsten am ball sind, rennen wir hin.
    if( amNaechsten ) {
//        System.out.println( "SpielerStrategie: Spieler "+spieler.nummer()+" (das bin ich) ist am naechsten..." );
      rennenZumBall( distance );
    } else if( ballNotSeenCount >9 ) {
      // wenn wir neunmal (komplette drehung) den ball nicht gesehen haben
      // zurueck zum start
      // bewegen wir uns mal an unsere ausgangsposition...
      // nur vorlaeufig: spielmodus = OFFENSIV;
      int spielmodus = OFFENSIV;
      double deltaX = xPosition[ spielmodus ][ spieler.nummer() -1 ] - spieler.positionX();
      double deltaY = yPosition[ spielmodus ][ spieler.nummer() -1 ] - spieler.positionY();
      distance = Math.sqrt( deltaX*deltaX + deltaY*deltaY );
      double eigentliche_richtung = eigentliche_richtung(deltaX, deltaY);
      double eigene_richtung = spieler.richtung();
      double richtung = bereinigt( eigentliche_richtung - eigene_richtung );
      // wir schaun in richtung unsrer ausgangsposition und sind weit genug
      // weg, hinrennen.
      if( Math.abs( richtung ) < 10 ) {
        if( distance > 5 ) {
          kom.dash( 60 );
        }
      } else {
        // drehen zum ausgangspunkt
        kom.turn( richtung );
      }
    } else {
      // wir haben weniger als 9 mal den ball nicht gesehen, suchen wir ihn...
      kom.turn( 40 );
    }
  }
// ende von play_on();

/**
 * aufstellen() - entscheidet, wie unsere spieler sich aufstellen...
 */
  public void aufstellen()
  {
    // nur vorlaeufig, wird vielleicht noch erweitert...
    int spielmodus = OFFENSIV;
    int nummer = spieler.nummer() -1;
//    System.out.println( "Strategie: bringe Spieler "+nummer+" an seine Position..." );
    kom.move( xPosition[ spielmodus ][ spieler.nummer()-1 ], yPosition[ spielmodus ][ spieler.nummer()-1 ] );
    //System.out.println("aufstellen... Seite: "+spiel.seite());
  }

 /**
  * eigener_kick_off() - was passiert wenn wir anstoss haben?
  */
  private void eigener_kick_off()
  {
    offensiv();
  }

/**
 * gegner_kick_off() - was passiert wenn der gegner anstoss hat?
 */
  private void gegner_kick_off()
  {
    defensiv();
  }

/**
  * eigener_goal_kick() - was passiert wenn wir abstoss haben?
  */
  private void eigener_goal_kick()
  {
    offensiv();
  }

/**
 * gegner_goal_kick() - was passiert wenn der gegner abstoss hat?
 */
  private void gegner_goal_kick()
  {
    defensiv();
  }

  private void eigener_kick_in()
  {
    offensiv();
  }

  private void gegner_kick_in()
  {
    defensiv();
  }

  private void eigener_free_kick()
  {
    offensiv();
  }

  private void gegner_free_kick()
  {
    defensiv();
  }

/**
 * eigener_corner_kick() - sorgt dafuer das mindestens einer unserer spieler
 *                         den eckstoss ausfuehrt.
 */
  private void eigener_corner_kick()
  {
    if(ball.positionX() >= 0)
    {
      boolean amNaechsten = true;
      aufgestellt = 0;
      double distance = ball.entfernung();
      try
      {
        // distance bestimmen
        int i = 0;
        for( i=3;(i<23) && (amNaechsten);i++ ) {
          if( ( WbObjekte[ i ] != null ) && ( WbObjekte[ i ].mannschaft() == 1 ) && ( WbObjekte[ i ].nummer() != 1 ) ) {
            if( WbObjekte[ i ].ballEntfernung() < distance ) {
              amNaechsten = false;
            }
          }
        }
      }
      catch( NullPointerException NPE )
      {
      }
      // wir sind am naechsten am ball
      if( amNaechsten ) {
        rennenZurEcke( distance );
      }
    } else {
    // wir sehn den ball nicht...
    }
  }

  private void gegner_corner_kick()
  {
    play_on(); // ! nur vorlufig
    //spter: vors eigene Tor laufen
  }

  private void eigener_offside()
  {
    defensiv();
    //spter evtl. Anzahl der Abseits merken und reagieren?
  }

  private void gegner_offside()
  {
    offensiv();
  }

  private void eigener_foul()
  {
    gegner_free_kick();
  }

  private void gegner_foul()
  {
    eigener_free_kick();
  }

  private void eigener_goalie_catch_ball()
  {
    offensiv();
  }

  private void gegner_goalie_catch_ball()
  {
    defensiv();
  }

  private void half_time()
  {
    aufstellen(); // ntig?
  }

  private void time_extended()
  {
    aufstellen(); // ntig?
  }

  private void offensiv()
  {
    play_on(); // ! nur vorlufig
  }

  private void defensiv()
  {
    play_on(); // ! nur vorlufig
  }

/**
 * rennenZumBall() - sorgt dafuer, dass mindestens einer unserer spieler
 *                   zum ball rennt
 */
  private void rennenZumBall( double distance ) {

    double ballWinkel = bereinigt( ball.winkel() );
    double richtung = spieler.richtung();
    double drehWinkel = 0;

    // nahe genug am ball?
    if( distance <= 0.7 )
    {
      //ja, tritt ihn
      //System.out.println("Strategie: bin beim ball -> kicken...");
      schiessen();
    }
    else
    {
      // nein, erstmal hinrennen...
      //      System.out.println("Strategie: ball gefunden -> hinrennen...");
      if(Math.abs( ball.relativer_winkel() ) < 10)
      {
        if(distance < 0.8)
          kom.dash(10);
        if(distance < 1.5)
          kom.dash(70);
        else if(distance < 3)
          kom.dash(80);
        else if(distance < 8)
          kom.dash(100);
        else if(distance < 10)
          kom.dash(80);
        else
          kom.dash(70);
      }
      else
      {
      // der winkel ist zu gross, richtungskorrektur
        kom.turn( ball.relativer_winkel() );
      }
    }
  }


/**
 * renneZurEcke() - rennt beim Eckball zur Ecke
 */
  private void rennenZurEcke( double distance ) {

    double ballWinkel = bereinigt( ball.winkel() );
    double richtung = spieler.richtung();
    double drehWinkel = 0;

    // nahe genug am ball?
    if( distance <= 0.7 )
    {
      //ja, tritt ihn
      eckStoss();
    }
    else
    {
      // nein, erstmal hinrennen...
      //      System.out.println("Strategie: ball gefunden -> hinrennen...");
      if(Math.abs( ball.relativer_winkel() ) < 10) // war drehwinkel
      {
        if(distance < 0.8)
          kom.dash(10);
        if(distance < 1.5)
          kom.dash(70);
        else if(distance < 3)
          kom.dash(80);
        else if(distance < 8)
          kom.dash(100);
        else if(distance < 10)
          kom.dash(80);
        else
          kom.dash(70);
      }
      else
      {
      // der winkel ist zu gross, richtungskorrektur
        kom.turn( ball.relativer_winkel() );
      }
    }
  }

/**
 * eckStoss() - fuehrt einen Eckstoss aus.
 */

  public void eckStoss()
  {
    int seite = spiel.seite();

    double zielX = seite*45 + 57.5;
    double zielY = 39;
    double deltaX = zielX - spieler.positionX();
    double deltaY = zielY - spieler.positionY();

    double distance = Math.sqrt( deltaX*deltaX + deltaY*deltaY );
    double eigentliche_richtung = eigentliche_richtung(deltaX, deltaY);
    double eigene_richtung = spieler.richtung();
    double richtung = bereinigt( eigentliche_richtung - eigene_richtung );

    if(Math.abs( richtung ) < 20 ) {
      kom.kick( 60,richtung );
    } else {
      kom.turn( richtung );
    }
  }

/**
 * schiessen() - bestimmt, wohin und wie stark der spieler den ball kickt
 */

  public void schiessen()
  {
    double zielX, zielY;
    int seite = spiel.seite();
    int naehesterSpieler = 0;

    double torX = seite*52.5 + 57.5;
    double torY = 39;

    if(Math.abs( spieler.richtung() ) > 180 ) // !! war > 45
    {
      kom.turn( -spieler.richtung() );
    }
    else
    {
      double torEntfernung = Math.sqrt( (torX - spieler.positionX())*(torX - spieler.positionX()) + (torY - spieler.positionY())*(torY - spieler.positionY()) );

      for(int i = 3; i<24; i++)
      {
        try
        {
          double torEntfernung2 = Math.sqrt( (torX - WbObjekte[ i ].positionX())*(torX - WbObjekte[ i ].positionX()) + (torY - WbObjekte[ i ].positionY())*(torY - WbObjekte[ i ].positionY()) );
          if( torEntfernung2 < torEntfernung ) {
            if( WbObjekte[ i ].entfernung() > 3 )
            {
              naehesterSpieler = i;
              torEntfernung = torEntfernung2;
            }
          }
        }
        catch(NullPointerException npe_schiessen)
        {
          break;
        }
      }

      if(naehesterSpieler == 0)
      {
        zielX = torX;
        zielY = torY;
      }
      else
      {
        zielX = WbObjekte[naehesterSpieler].positionX();
        zielY = WbObjekte[naehesterSpieler].positionY();
      }

      double deltaX = zielX - spieler.positionX();
      double deltaY = zielY - spieler.positionY();
      double distance = Math.sqrt( deltaX*deltaX + deltaY*deltaY );

      double eigentliche_richtung = eigentliche_richtung(deltaX, deltaY);
      double eigene_richtung = spieler.richtung();
      double richtung = bereinigt( eigentliche_richtung - eigene_richtung );

      //System.out.println("Strategie: eigene Richtung: "+ eigene_richtung);
      //System.out.println("Strategie: eigentliche Richtung: "+ eigentliche_richtung);
      //System.out.println("Strategie: schiesse in Richtung "+ richtung);
      //System.out.println("Strategie: Zyklus: "+ spiel.zyklus());

      if(zielX == torX)
      {
        if( distance > 10 )
        {
          kom.kick( 100, richtung );
        }
        else if( distance > 5 )
        {
          double abweichung = -1;
          int faktor = (int)Math.floor( 2 * Math.random() +0.5 );
          kom.kick( 100, richtung +abweichung+( faktor ) );
        }
        else
        {
          double abweichung = -0.5;
          int faktor = (int)Math.floor( 2 * Math.random() +0.5 );
          kom.kick( 100, richtung +abweichung+( faktor ) );
        }
      }
      else
      {
        kom.kick(Math.min(100,distance*2),richtung);
      }
    }
  }

/**
 * eigentliche_richtung() - hilfsmethode, macht das rechnen einfacher ;)
 * @param <code>double</code> : x - koordinate
 * @param <code>double</code> : y - koordinate
 * @return <code>double</code> : eigentliche_richtung {-180..180}
 */
  private double eigentliche_richtung(double x, double y)
  {
    double eigentliche_richtung = -1000;
    double beta = Math.toDegrees( Math.atan(Math.abs( y/x ) ) );
    //System.out.println(" beta: " + beta);

    if((x >= 0) && (y >= 0))
    {
      //System.out.println("x >= 0, y >= 0");
      if(spiel.seite() == 1)
      {
        eigentliche_richtung = beta;
      }
      else if(spiel.seite() == -1)
      {
        eigentliche_richtung = -180 + beta;
      }
    }
    else if((x >= 0) && (y < 0))
    {
      //System.out.println("x >= 0, y < 0");
      if(spiel.seite() == 1)
      {
        eigentliche_richtung = -beta;
      }
      else if(spiel.seite() == -1)
      {
        eigentliche_richtung = 180 - beta;
      }
    }
    else if((x < 0) && (y >= 0))
    {
      //System.out.println("x < 0, y >= 0");
      if(spiel.seite() == 1)
      {
        eigentliche_richtung = 180 - beta;
      }
      else if(spiel.seite() == -1)
      {
        eigentliche_richtung = -beta;
      }
    }
    else if((x<0) && (y<0))
    {
      //System.out.println("x < 0, y < 0");
      if(spiel.seite() == 1)
      {
        eigentliche_richtung = -180 + beta;
      }
      else if(spiel.seite() == -1)
      {
        eigentliche_richtung = beta;
      }
    }

    //System.out.println("eigentliche Richtung: " + eigentliche_richtung);
    return eigentliche_richtung;
  }


/**
 * <code>double</code> bereinigt( double wert ) - liefert korrekte winkel
 * @param <code>double</code> wert
 * @return <code>double</code> bereinigter winkel {-180..180}
 */
  private double bereinigt(double wert)
  {
    if(wert > 180)
    {
      wert = wert - 360;
    }
    else if(wert < -180)
    {
      wert = wert + 360;
    }
    return wert;
  }
}
