// Strategie.java stand: 20020707
/**
 * Strategie: abstrakte klasse fuer SpielerStrategie und GoalieStrategie.
 *
 * @author <a href="mailto:rmathes@uni-mannheim.de">Rene M</a>
 * @version 0.0.1
 * @see <code>Weltbild</code>
 * @see <code>kommunikation</code>
 * @see <code>Loki</code>
 * @see <code>Strategie</code>
 * @see <code>GoalieStrategie</code>
 * @see <code>SpielerStrategie</code>
 */
public abstract class Strategie {

  protected int seite = 1; // !!! standard spter auf 0 stellen und im WB aktualisieren
  protected final int TOR = -1000;
  protected final static double FEHLT = -1000;
  // Aufstellungspositionen:
  protected static final int OFFENSIV = 0;
  protected static final int DEFENSIV = 1;
/**
 * die folgenden beiden arrays speichern die x und y position
 * (in unserem koordinatensystem) der einzelnen startaufstellungen.
 * hier koennen beliebig viele aufstellungen z.b. offensiv oder defensiv
 * definiert werden.
 */
  protected static final int[][] xPosition =
  {
    /** offensive aufstellung */
    {  7,11,15,15,11,40,33,33,40,55,49 },
    // andere alternative
    {  9,20,25,25,20,40,37,37,40,55,57 }
  };
  protected static final int[][] yPosition =
  {
    /** offensive aufstellung */
    { 39,26,35,43,52,15,32,49,65,37,42 },
    // andere alternative
    { 39,20,35,43,58,15,30,51,65,37,50 }
  };

/**
 * handle( kommunikation kom, WbObjekt[] WbObjekte );
 * nimmt eine referenz auf die kommunikation und die vom weltbild erzeugten
 * objekte entgegen und steuert den spieler anhand der verschiedenen spielmodi
 *
 * @param <code>kommunikation</code> kom : die kommunikatins-klasse
 * @param <code>WbObject[]</code> WbObjekte : vom Weltbild erzeugtes Array
 * @return <code>boolean</code> stillRunning : um das programm zu beenden.
 */
  public boolean handle( kommunikation kom, WbObjekt[] WbObjekte ) {
    return true;
  }
}