/**
 * In der Klasse <code>WbSpielObjekt</code> werden die bentigten
 * Eigenschaften bzw. Zustnde der Gegen- und Mitspieler gespeichert.
 *
 * @author <a href="mailto:dabrecht@uni-mannheim.de">David Brechtel</a>
 * @version 1.0
 *
 * @see WbObjekt
 *
 */

public class WbAndereSpielerObjekt extends WbObjekt
{
  boolean torwart;
  int mannschaft;
  double positionX, positionY, geschwindigkeitX, geschwindigkeitY;
  int nummer;
  double ballEntfernung, entfernung;

  /**
   * Konstruktor: erzeugt ein neues <code>WbAndereSpielerObjekt</code> mit
   * allen zugehrigen SpielerEigenschaften, die beim Aufruf bergeben
   * werden.
   *
   */
  public WbAndereSpielerObjekt(int zyklus, int nummer, int mannschaft, double positionX, double positionY, double geschwindigkeitX, double geschwindigkeitY, boolean torwart, double entfernung, double ballEntfernung)
  {
    this.zyklus = zyklus;
    this.nummer = nummer;
    this.mannschaft = mannschaft;
    this.geschwindigkeitX = geschwindigkeitX;
    this.geschwindigkeitY = geschwindigkeitY;
    this.positionX = positionX;
    this.positionY = positionY;
    this.torwart = torwart;
    this.ballEntfernung = ballEntfernung;
    this.entfernung = entfernung;
  }


  /**
   * liefert einen Wahrheitswert zurck, ob der Spieler Torwart
   * ist oder nicht
   */
  public boolean torwart()
  {
    return torwart;
  }

  /**
   * liefert die Entfernung des Spielers zum Ball zurck
   */
  public double ballEntfernung()
  {
    return ballEntfernung;
  }

  /**
   * liefert die Entfernung des Gegners/Mitspielers zu dem
   * Spieler selbst zurck
   */
  public double entfernung()
  {
    return entfernung;
  }

  /**
   * liefert die Rckennummer des Spielers zum Ball zurck oder
   * '0', falls man die Nummer nicht sieht
   */
  public int nummer()
  {
    return nummer;
  }

  /**
   * liefert <br>
   * '1', falls der Spieler in der eigenen Mannschaft ist, <br>
   * '-1', falls der Spieler ein Gegner ist und <br>
   * '0', falls man die Mannschaftszugehrigkeit nicht feststellen kann
   *
   */
  public int mannschaft()
  {
    return mannschaft;
  }

  /**
   * liefert die Geschwindigkeit des Spielers in X-Richtung zurck
   */
  public double geschwindigkeitX()
  {
    return geschwindigkeitX;
  }

  /**
   * liefert die Geschwindigkeit des Spielers in Y-Richtung zurck
   */
  public double geschwindigkeitY()
  {
    return geschwindigkeitY;
  }

  /**
   * liefert die X-Koordinate der Position des Spielers
   * auf dem Spielfeld zurck
   */
  public double positionX()
  {
    return positionX;
  }

  /**
   * liefert die Y-Koordinate der Position des Spielers
   * auf dem Spielfeld zurck
   */
  public double positionY()
  {
    return positionY;
  }

}
