/**
 * In der Klasse <code>WbSpielObjekt</code> werden die bentigten
 * Eigenschaften bzw. Zustnde des Balls gespeichert.
 *
 * @author <a href="mailto:dabrecht@uni-mannheim.de">David Brechtel</a>
 * @version 1.0
 *
 * @see WbObjekt
 *
 */
public class WbBallObjekt extends WbObjekt
{
  double positionX, positionY, geschwindigkeitX, geschwindigkeitY, entfernung, winkel, relativer_winkel;

  /**
   * Konstruktor: erzeugt ein neues <code>WbBallObjekt</code> mit
   * allen zugehrigen Balleigenschaften, die beim Aufruf bergeben
   * werden.
   *
   */
  public WbBallObjekt(int zyklus, double positionX, double positionY, double geschwindigkeitX, double geschwindigkeitY, double entfernung, double winkel, double relativer_winkel)
  {
    this.positionX = positionX;
    this.positionY = positionY;
    this.zyklus = zyklus;
    this.geschwindigkeitX = geschwindigkeitX;
    this.geschwindigkeitY = geschwindigkeitY;
    this.entfernung = entfernung;
    this.winkel = winkel;
    this.relativer_winkel = relativer_winkel;
  }

  /**
   * liefert die Geschwindigkeit des Balls in X-Richtung zurck
   */
  public double geschwindigkeitX()
  {
    return geschwindigkeitX;
  }

  /**
   * liefert die Geschwindigkeit des Balls in Y-Richtung zurck
   */
  public double geschwindigkeitY()
  {
    return geschwindigkeitY;
  }

  /**
   * liefert die X-Koordinate der Position des Balls auf dem Spielfeld zurck
   */
  public double positionX()
  {
    return positionX;
  }

  /**
   * liefert die Y-Koordinate der Position des Balls auf dem Spielfeld zurck
   */
  public double positionY()
  {
    return positionY;
  }

  /**
   * liefert die Entfernung des Balls vom Spieler selbst zurck
   */
  public double entfernung()
  {
    return entfernung;
  }

  /**
   * liefert den absoluten Winkel zurck, in dem der Ball liegt
   */
  public double winkel()
  {
    return winkel;
  }

  /**
   * liefert den relativen Winkel zurck, in dem der Ball zur
   * Richtung des Spielers liegt
   */
  public double relativer_winkel()
  {
    return relativer_winkel;
  }

  /**
   * liefert den absoluten Winkel zurck, in dem der Ball liegt
   */
  public double richtung()
  {
    return winkel;
  }
}