/**
 * Diese abstrakte Klasse stellt Funktionen und Attribute
 * zur Verfgung, die von den von dieser Klassen abgeleiteten Objekten
 * berschrieben werden knnen.
 *
 * @author <a href="mailto:dabrecht@uni-mannheim.de">David Brechtel</a>
 * @version 1.0
 *
 * @see Weltbild
 * @see WbBallObjekt
 * @see WbSpielerObjekt
 * @see WbSpielObjekt
 * @see WbRufObjekt
 * @see WbAndereSpielerObjekt
 *
 */

public abstract class WbObjekt
{

  // Der Zyklus ist in allen abgeleiteten Objekten Bestandteil.
  protected int zyklus;

  /**
   * liefert den Zeitzyklus des Spiels zurck
   */
  public int zyklus()
  {
    return zyklus;
  }

  /**
   * liefert als default den Wert '0' zurck
   */
  public double ballEntfernung()
  {
    return 0;
  }

  /**
   * liefert als default den Wert '0' zurck
   */
  public double relative_blickrichtung()
  {
    return 0;
  }

  /**
   * liefert als default den Wert '-1000' zurck
   */
  public double positionX()
  {
    return -1000;
  }

  /**
   * liefert als default den Wert '0' zurck
   */
  public double positionY()
  {
    return 0;
  }

  /**
   * liefert als default den Wert '0' zurck
   */
  public double geschwindigkeitX()
  {
    return 0;
  }

  /**
   * liefert als default den Wert '0' zurck
   */
  public double geschwindigkeitY()
  {
    return 0;
  }

  /**
   * liefert als default den Wert '0' zurck
   */
  public double richtung()
  {
    return 0;
  }

  /**
   * liefert als default den Wert '0' zurck
   */
  public int seite()
  {
    return 0;
  }

  /**
   * liefert als default den Wert '0' zurck
   */
  public int eigeneTore()
  {
    return 0;
  }

  /**
   * liefert als default den Wert '0' zurck
   */
  public int gegnerischeTore()
  {
    return 0;
  }

  /**
   * liefert als default den Wert 'null' zurck
   */
  public String status()
  {
    return null;
  }

  /**
   * liefert als default den Wert '0' zurck
   */
  public int nummer()
  {
    return 0;
  }

  /**
   * liefert als default den Wert 'null' zurck
   */
  public String viewQuality()
  {
    return null;
  }

  /**
   * liefert als default den Wert 'null' zurck
   */
  public String viewWidth()
  {
    return null;
  }

  /**
   * liefert als default den Wert '0' zurck
   */
  public double effort()
  {
    return 0;
  }

  /**
   * liefert als default den Wert '0' zurck
   */
  public double recovery()
  {
    return 0;
  }

  /**
   * liefert als default den Wert '0' zurck
   */
  public double blickrichtung()
  {
    return 0;
  }

  /**
   * liefert als default den Wert '0' zurck
   */
  public int mannschaft()
  {
    return 0;
  }

  /**
   * liefert als default den Wert '0' zurck
   */
  public double entfernung()
  {
    return 0;
  }

  /**
   * liefert als default den Wert '0' zurck
   */
  public double winkel()
  {
    return 0;
  }

  /**
   * liefert als default den Wert '0' zurck
   */
  public double relativer_winkel()
  {
    return 0;
  }

  /**
   * liefert als default den Wert 'null' zurck
   */
  String ruf()
  {
    return null;
  }

  /**
   * liefert als default den Wert 'false' zurck
   */
  boolean team()
  {
    return false;
  }
}
