/**
 * In der Klasse <code>WbSpielObjekt</code> werden die Rufe von
 * Mit- und Gegenspielern gespeichert.
 *
 * @author <a href="mailto:dabrecht@uni-mannheim.de">David Brechtel</a>
 * @version 1.0
 *
 * @see WbObjekt
 *
 */

public class WbRufObjekt extends WbObjekt
{
  String ruf;
  boolean team;
  double richtung;

  /**
   * Konstruktor: erzeugt ein neues <code>WbRufObjekt</code> mit
   * allen zugehrigen Rufeigenschaften, die beim Aufruf bergeben
   * werden.
   *
   */
  public WbRufObjekt(int zyklus, boolean team, double richtung, String ruf)
  {
    this.ruf = ruf;
    this.zyklus = zyklus;
    this.team = team;
    this.richtung = richtung;
  }

  /**
   * liefert den Inhalt des Rufs zurck
   */
  public String ruf()
  {
    return ruf;
  }

  /**
   * liefert die Richtung zurck, aus welcher der Ruf kam
   */
  public double richtung()
  {
    return richtung;
  }

  /**
   * liefert einen Wahrheitswert zurck, ob der Spieler, von
   * dem der Ruf kam im eigenen Team ist
   */
  public boolean team()
  {
    return team;
  }
}