/**
 * In der Klasse <code>WbSpielObjekt</code> werden die bentigten
 * Eigenschaften bzw. Zustnde des Spiels gespeichert.
 *
 * @author <a href="mailto:dabrecht@uni-mannheim.de">David Brechtel</a>
 * @version 1.0
 *
 * @see WbObjekt
 *
 */


public class WbSpielObjekt extends WbObjekt
{
  int eigeneTore, gegnerischeTore, seite;
  String status;

  /**
   * Konstruktor: erzeugt ein neues <code>WbSpielObjekt</code> mit
   * allen zugehrigen Spielzustnden, die beim Aufruf bergeben
   * werden.
   *
   */
  public WbSpielObjekt(int zyklus, int seite, String status, int eigeneTore, int gegnerischeTore)
  {
    this.zyklus = zyklus;
    this.eigeneTore = eigeneTore;
    this.gegnerischeTore = gegnerischeTore;
    this.status = status;
    this.seite = seite;
  }

  /**
   * liefert die Seite zurck, von welcher der Spieler spielt: <br>
   * '1' fr die linke seite und <br>
   * '-1' fr die rechte Seite
   */
  public int seite()
  {
    return seite;
  }

  /**
   * liefert die Anzahl der von der eigenen Mannschaft
   * geschossenen Tore zurck
   */
  public int eigeneTore()
  {
    return eigeneTore;
  }

  /**
   * liefert die Anzahl der von der gegnerischen Mannschaft
   * geschossenen Tore zurck
   */
  public int gegnerischeTore()
  {
    return gegnerischeTore;
  }

  /**
   * liefert den Spielstatus als String zurck so wie er vom
   * Server bergeben wird (z.B. 'play_on', 'before_kick_off' etc.)
   */
  public String status()
  {
    return status;
  }


  /**
   * liefert den aktuellen Spielzyklus zurck
   */
  public int zyklus()
  {
    return zyklus;
  }
}