/**
 * In der Klasse <code>WbSpielObjekt</code> werden die bentigten
 * Eigenschaften bzw. Zustnde des Spielers selbst gespeichert.
 *
 * @author <a href="mailto:dabrecht@uni-mannheim.de">David Brechtel</a>
 * @version 1.0
 *
 * @see WbObjekt
 *
 */
public class WbSpielerObjekt extends WbObjekt
{
  String viewQuality, viewWidth;
  int nummer;
  double mannschaft, positionX, positionY, geschwindigkeitX, geschwindigkeitY, richtung, blickrichtung, relative_blickrichtung, recovery, effort;

  /**
   * Konstruktor: erzeugt ein neues <code>WbSpielerObjekt</code> mit
   * allen zugehrigen eigenen Eigenschaften, die beim Aufruf bergeben
   * werden.
   *
   */
  public WbSpielerObjekt(int zyklus, int nummer, double positionX, double positionY, double geschwindigkeitX, double geschwindigkeitY, double richtung, double blickrichtung, double recovery, double effort, double relative_blickrichtung, String viewQuality, String viewWidth)
  {
    this.zyklus = zyklus;
    this.nummer = nummer;
    this.effort = effort;
    this.geschwindigkeitX = geschwindigkeitX;
    this.geschwindigkeitY = geschwindigkeitY;
    this.richtung = richtung;
    this.positionX = positionX;
    this.positionY = positionY;
    this.viewQuality = viewQuality;
    this.viewWidth = viewWidth;
    this.blickrichtung = blickrichtung;
    this.recovery = recovery;
  }

  /**
   * liefert die Rckennummer des Spielers zurck
   */
  public int nummer()
  {
    return nummer;
  }

  /**
   * liefert eine '1' zurck
   */
  public int mannschaft()
  {
    return 1;
  }

  /**
   * liefert die sog. 'ViewQuality' zurck
   */
  public String viewQuality()
  {
    return viewQuality;
  }

  /**
   * liefert die sog. 'ViewWidth' zurck
   */
  public String viewWidth()
  {
    return viewWidth;
  }

  /**
   * liefert die eigene Geschwindigkeit in X-Richtung zurck
   */
  public double geschwindigkeitX()
  {
    return geschwindigkeitX;
  }

  /**
   * liefert die eigene Geschwindigkeit in Y-Richtung zurck
   */
  public double geschwindigkeitY()
  {
    return geschwindigkeitY;
  }

  /**
   * liefert die eigene (Aus-)Richtung zurck
   */
  public double richtung()
  {
    return richtung;
  }

  /**
   * liefert die X-Koordinate der eigenen Position auf dem Spielfeld zurck
   */
  public double positionX()
  {
    return positionX;
  }

  /**
   * liefert die Y-Koordinate der eigenen Position auf dem Spielfeld zurck
   */
  public double positionY()
  {
    return positionY;
  }

  /**
   * liefert den Energie 'effort' des Spielers zurck
   */
  public double effort()
  {
    return effort;
  }

  /**
   * liefert den Energie 'recovery' des Spielers zurck
   */
  public double recovery()
  {
    return recovery;
  }

  /**
   * liefert die absolute Blickrichtung des Spielers zurck,
   * die Nullrichtung liegt in Richtung der X-Achse,
   * immer in Richtung des gegnerischen Tors
   */
  public double blickrichtung()
  {
    return blickrichtung;
  }

  /**
   * liefert die Blickrichtung des Spielers relativ zu
   * seiner Krperrichtung (richtung) zurck
   */
  public double relative_blickrichtung()
  {
    return relative_blickrichtung;
  }

}
