// hearObject.java stand: 20020628
/**
 * repraesentiert alle gehoerten "objekte"
 * wird von der kommunikation erzeugt und ans weltbild weitergegeben.
 *
 * @author <a href="mailto:rmathes@uni-mannheim.de">Rene</a>
 * @version 0.0.1
 * @see <code>kommunikation.java</code>
 * @see <code>weltbild.java</code>
 *
 */
public class hearObject {

/**
 * private attribute des objekts
 * @see rcssmanual-7.07.pdf client sensor protocol
 */
  private int time;
  private String sender;
  private double direction;
  private String message;
/**
 * vonUns - ist der ruf von uns?
 * wenn true: ja, ruf ist von uns
 * wenn false:
 * - ruf ist nicht von uns
 * - - sender == "Direction" ?
 * - - wenn true: gegnerischer Ruf
 * - - wenn false: Ruf von referee oder coach etc
 */
  private boolean vonUns;
// "konstante, die fehlenden wert repraesentiert
  private double FEHLT = -1000;

/**
 * hearObject() - konstruktor des objekts
 */
  public hearObject( int time, String sender, String message ) {
    this.time = time;
    this.sender = sender;
    this.direction = FEHLT;
    this.message = message;
    this.vonUns = false;
/** methode zur ueberpruefung der Nachricht */
    validateMessage();
  }
// ende des konstruktors

/**
 * time() - gibt den timestamp des gehoerten rufes zurueck
 * @return <code>int</code> time {>=0}
 */
  public int time() { return this.time; }

/**
 * sender() - gibt den sender des gehoerten rufes zurueck
 * interessant ist im moment nur "referee" oder "Direction"
 * @return <code>String</code> sender {referee|Direction}
 */
  public String sender() { return this.sender; }

/**
 * direction() - gibt die richtung des gehoerten Rufes zurueck
 * @return <code>double</code> direction {-180..180 grad}
 */
  public double direction() { return this.direction; }

/**
 * message() - gibt die nachricht des gehoerten rufes zurueck
 * @return <code>String</code> message {message}
 */
  public String message() { return this.message; }

/**
 * vonUns() - kommt die nachricht von uns oder nicht?
 * @return <code>Boolean</code> vonUns {true|false}
 */
  public boolean vonUns() { return this.vonUns; }

/**
 * validateMessage() - ueberprueft die erhaltene message
 */
  private void validateMessage() {
// ist sender eine zahl?
     boolean isNum = true;
     double dir = FEHLT;
     try {
       dir = Double.parseDouble( this.sender );
     } catch( NumberFormatException NFE ) {
       dir = FEHLT;
       isNum = false;
    }
    if( isNum ) {
// ab hier ueberpruefung der nachricht und decodierung unserer Rufe
      this.direction = dir;
      this.sender = "Direction";
// !rene: pseudo ueberpruefung, sollte noch verbessert werden!
      if( this.message.startsWith( "dummy" ) ) {
// ruf von uns, decodieren...
        this.vonUns = true;
// !rene: pseudo decodierung, sollte noch verbessert werden!
        this.message = this.message.substring( 5 );
      } else {
// gegnerischer ruf
        this.vonUns = false;
      }
    } else {
// wenn sender keine Zahl, dann ist der ruf nicht von uns, da "self" gefiltert wird.
      this.vonUns = false;
    }
  }
// ende von validateMessage()

}
// ende der klasse hearObject
