// seeObject.java stand: 20020628

/** wird benoetigt fuer StringTokenizer */
import java.util.*;

/**
 * repraesentiert alle gesehenen "objekte"
 * wird von der kommunikation erzeugt und ans weltbild weitergegeben.
 *
 * @author <a href="mailto:rmathes@uni-mannheim.de">Rene</a>
 * @version 0.0.1
 * @see <code>kommunikation.java</code>
 * @see <code>weltbild.java</code>
 *
 */
public class seeObject {

/**
 * private attribute des objekts
 * @see rcssmanual-7.07.pdf 4.2.2: client sensor protocol
 */
  private int time;
  private String[] objName;
  private double distance;
  private double direction;
  private double distChange;
  private double dirChange;
  private double bodyFacingDir;
  private double headFacingDir;
  private String teamname;
  private int uniformNumber;
/** "konstante" um fehlende informationen anzuzeigen */
  private double FEHLT = -1000;

/**
 * _seeObject() - der eigendliche konstruktor des objekts
 */
  private void _seeObject( int time,
                    String objName,
                    double distance, double direction,
                    double distChange, double dirChange,
                    double bodyFacingDir, double headFacingDir )
  {
    this.time = time;
/** ab hier wird der string objName in einzelne tokens zerlegt und zum array of string String[] objName */
// aufteilen in tokens, jeweils durch spaces getrennt
    int i = 0;
    StringTokenizer tokenizer = new StringTokenizer( objName, " " );
    this.objName = new String[ tokenizer.countTokens() ];
    while( tokenizer.hasMoreTokens() ) { this.objName[ i++ ] = new String( tokenizer.nextToken() ); }
/** ende der aufteilung des strings */
    this.distance = distance;
    this.direction = direction;
    this.distChange = distChange;
    this.dirChange = dirChange;
    this.bodyFacingDir = bodyFacingDir;
    this.headFacingDir = headFacingDir;
/**
 * die folgenden beiden variablen werden vielleicht noch veraendert,
 * aber erstmal auf standardwerte gesetzt
 */
    this.teamname = "";
    this.uniformNumber = (int)Math.floor( FEHLT );
/**
 * sehen wir einen spieler?
 * wenn true: sehen wir den teamnamen?
 * vielleicht sehen wir auch seine nummer...
 *
 * !rene: brauchen wir hier noch ein flag "goalie", oder wo soll das ueberprueft werden?
 *
 */
    if( this.objName[ 0 ].equals( "p" ) ) {
      if( this.objName.length > 1 ) {
        if( this.objName[ 1 ].startsWith( "\"" ) ) {
          this.objName[ 1 ] = this.objName[ 1 ].substring( 1, this.objName[ 1 ].length() -1 );
        }
        this.teamname = this.objName[ 1 ];
      }
      if( this.objName.length > 2 ) { this.uniformNumber = Integer.parseInt( this.objName[ 2 ] ); }
// !rene: auskommentieren wenns das goalie flag gibt
// !rene:     if( this.objName.length > 3 ) { this.goalie = true; }
    }

  }
// ende des konstruktors

/**
 * seeObject() - wir bekommen die vollstaendigen (acht) daten
 */
  public seeObject( int time,
                    String objName,
                    double distance, double direction,
                    double distChange, double dirChange,
                    double bodyFacingDir, double headFacingDir )
  {
    _seeObject( time, objName, distance, direction, distChange, dirChange, bodyFacingDir, headFacingDir );
  }
// ende der ueberladung

/**
 * der konstruktor wird mehrere male ueberladen, je nach menge der daten die wir bekommen.
 */

/**
 * seeObject() - wir bekommen nur drei daten
 */
  public seeObject( int time, String objName, double direction )
  {
    _seeObject( time, objName, FEHLT, direction, FEHLT, FEHLT, FEHLT, FEHLT );
  }
// ende der ueberladung

/**
 * seeObject() - wir bekommen nur vier daten
 */
  public seeObject( int time, String objName, double distance, double direction )
  {
    _seeObject( time, objName, distance, direction, FEHLT, FEHLT, FEHLT, FEHLT );
  }
// ende der ueberladung

/**
 * seeObject() - wir bekommen nur sechs daten
 */
  public seeObject( int time, String objName, double distance, double direction, double distChange, double dirChange )
  {
    _seeObject( time, objName, distance, direction, distChange, dirChange, FEHLT, FEHLT );
  }
// ende der ueberladung


/**
 * @return <code>int</code> time {>=0}
 */
  public int time() { return this.time; }

/**
 * @return <code>String[]</code> objName {@see 4.2.2}
 */
  public String[] objName() { return this.objName; }

/**
 * @param <code>int</code> n {n<=objName.length}
 * @return <code>String</code> objName[n]
 */
  public String objName( int n ) {
    if( n < this.objName.length ) { return this.objName[ n ]; }
    else { return "OUT_OF_BOUNDS"; }
  }

/**
 * @return <code>double</code> distance {>=0}
 */
  public double distance() { return this.distance; }

/**
 * @return <code>double</code> direction {-180..180 grad}
 */
  public double direction() { return this.direction; }

/**
 * @return <code>double</code> distChange {real}
 */
  public double distChange() { return this.distChange; }

/**
 * @return <code>double</code> dirChange {real}
 */
  public double dirChange() { return this.dirChange; }

/**
 * @return <code>double</code> bodyFacingDir {-180..180 grad}
 */
  public double bodyFacingDir() { return this.bodyFacingDir; }

/**
 * @return <code>double</code> headFacingDir {-180..180 grad}
 */
  public double headFacingDir() { return this.headFacingDir; }

/**
 * @return <code>String</code> teamname {String}
 */
  public String teamname() { return this.teamname; }

/**
 * @return <code>int</code> uniformNumber {1..11}
 */
  public int uniformNumber() { return this.uniformNumber; }

}
// ende der klasse seeObject
