// sense_bodyObject.java stand: 20020604
/**
 * repraesentiert alle "gesensten objekte"
 * wird von der kommunikation erzeugt und ans weltbild weitergegeben.
 *
 * @author <a href="mailto:rmathes@uni-mannheim.de">Rene</a>
 * @version 0.0.1
 * @see <code>kommunikation.java</code>
 * @see <code>weltbild.java</code>
 *
 */
public class sense_bodyObject {

/**
 * private attribute des objekts
 * @see rcssmanual-7.07.pdf
 */
  private int time;
  private String viewQuality;
  private String viewMode;
  private double stamina;
  private double effort;
  private double amountOfSpeed;
  private double directionOfSpeed;
  private double headDirection;
  private int kickCount;
  private int dashCount;
  private int turnCount;
  private int sayCount;
  private int turnNeckCount;
  private int catchCount;
  private int moveCount;
  private int changeViewCount;

/**
 * sense_bodyObject() - der konstruktor des objekts
 */
  public sense_bodyObject( int time,
                           String viewQuality, String viewMode,
                           double stamina, double effort,
                           double amountOfSpeed, double directionOfSpeed,
                           double headDirection,
                           int kickCount, int dashCount, int turnCount, int sayCount,int turnNeckCount,
                           int catchCount, int moveCount, int changeViewCount )
 {
   this.time = time;
   this.viewQuality = viewQuality;
   this.viewMode = viewMode;
   this.stamina = stamina;
   this.effort = effort;
   this.amountOfSpeed = amountOfSpeed;
   this.directionOfSpeed = directionOfSpeed;
   this.headDirection = headDirection;
   this.kickCount = kickCount;
   this.dashCount = dashCount;
   this.turnCount = turnCount;
   this.sayCount = sayCount;
   this.turnNeckCount = turnNeckCount;
   this.catchCount = catchCount;
   this.moveCount = moveCount;
   this.changeViewCount = changeViewCount;
}
// ende des konstruktors

/**
 * @return <code>int</code> time {>=0}
 */
  public int time() { return this.time ; }

/**
 * @return <code>String</code> viewQuality {high|low}
 */
  public String viewQuality() { return this.viewQuality; }

/**
 * @return <code>String</code> viewMode {narrow|normal|wide}
 */
  public String viewMode() { return this.viewMode; }

/**
 * @return <code>double</code> stamina {>=0}
 */
  public double stamina() { return this.stamina; }

/**
 * @return <code>double</code> effort {>=0}
 */
  public double effort() { return this.effort; }

/**
 * @return <code>double</code> amountOfSpeed {>=0}
 */
  public double amountOfSpeed() { return this.amountOfSpeed; }

/**
 * @return <code>double</code> directionOfSpeed {-180..180 grad}
 */
  public double directionOfSpeed() { return this.directionOfSpeed; }

/**
 * @return <code>double</code> headDirection {-180..180 grad}
 */
  public double headDirection() { return this.headDirection; }

/**
 * @return <code>int</code> kickCount {>=0}
 */
  public int kickCount() { return this.kickCount; }

/**
 * @return <code>int</code> dashCount {>=0}
 */
  public int dashCount() { return this.dashCount; }

/**
 * @return <code>int</code> turnCount {>=0}
 */
  public int turnCount() { return this.turnCount; }

/**
 * @return <code>int</code> sayCount {>=0}
 */
  public int sayCount() { return this.sayCount; }

/**
 * @return <code>int</code> turnNeckCount {>=0}
 */
  public int turnNeckCount() { return this.turnNeckCount; }

/**
 * @return <code>int</code> catchCount {>=0}
 */
  public int catchCount() { return this.catchCount; }

/**
 * @return <code>int</code> moveCount {>=0}
 */
  public int moveCount() { return this.moveCount; }

/**
 * @return <code>int</code> changeViewCount {>=0}
 */
  public int changeViewCount() { return this.changeViewCount; }

}
// ende der klasse sense_bodyObject